#
# spec file for package post-build-checks
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define version_unconverted 13.2+git20160512.be9650e

Name:           post-build-checks
Summary:        post checks for build after rpms have been created
License:        GPL-2.0+
Group:          Development/Tools/Building
Version:        13.2+git20160512.be9650e
Release:        2.5
PreReq:         aaa_base permissions sed
Requires:       aaa_base-malloccheck
Requires:       gawk
Url:            https://github.com/openSUSE/post-build-checks
#
# Note: don't rebuild this manually. Instead submit your patches
# for inclusion in the git repo!
#
# git clone https://github.com/openSUSE/post-build-checks.git
# osc service dr
#
Source0:        %{name}-%{version}.tar.xz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
some scripts to check for problems like test-installing the newly
created rpms and checking the logfile for errors.

This package will also set/change the following sysconfig variables, so
it may not be a good idea to install this to a running system:
/etc/sysconfig/security:PERMISSION_SECURITY="secure"
/etc/sysconfig/clock:TIMEZONE="UTC"



%prep
%setup -q

%build
# nothing to do

%install
install -d $RPM_BUILD_ROOT/usr/lib/build/checks
install -d $RPM_BUILD_ROOT/usr/lib/build/checks-data
install -d $RPM_BUILD_ROOT/usr/lib/build/helper
install -m 755 checks/* $RPM_BUILD_ROOT/usr/lib/build/checks
install -m 644 checks-data/* $RPM_BUILD_ROOT/usr/lib/build/checks-data
install -m 755 helper/* $RPM_BUILD_ROOT/usr/lib/build/helper
install -m 644 -D suse-buildsystem.sh  $RPM_BUILD_ROOT/etc/profile.d/suse-buildsystem.sh
chmod 755 $RPM_BUILD_ROOT/usr/lib/build/checks-data/check*

( echo %_libdir 
  echo /usr/local/%_lib
  echo %_lib
  echo %_libdir/Xaw3d
  echo /usr/x86_64-suse-linux/lib
  echo /opt/kde3/%_lib
)  > $RPM_BUILD_ROOT/etc/suse-ignored-rpaths.conf

%check
for i in tests/xx*.c
do
	(echo "Executing(%%build)" ; gcc $RPM_OPT_FLAGS -c $i 2>&1)| checks-data/check_gcc_output 2>&1|grep "^[WE]"
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
# do nothing when not in a build chroot
if ! test -e /.buildenv; then
    exit 0
fi
sed -i -e "s@^PERMISSION_SECURITY=.*@PERMISSION_SECURITY=\"secure\"@" /etc/sysconfig/security
if [ -f /etc/sysconfig/clock ] ; then
sed -i -e "s@^TIMEZONE=.*@TIMEZONE=\"UTC\"@" /etc/sysconfig/clock
fi
UNAME=/bin/uname
if test -f /usr/bin/uname ; then
    UNAME=/usr/bin/uname
fi
if test -f $UNAME -a ! -L $UNAME ; then
    mv $UNAME $UNAME.bin
    ln -s /usr/lib/build/helper/uname.sh $UNAME
fi

%preun
if ! test -e /.buildenv; then
    exit 0
fi
UNAME=/bin/uname
if test -f /usr/bin/uname.bin ; then
    UNAME=/usr/bin/uname
fi
if test "$1" = 0 -a -f $UNAME.bin ; then
    mv $UNAME.bin $UNAME
fi

%files
%defattr(-, root, root)
%doc COPYING
/usr/lib/build
/etc/profile.d/suse-buildsystem.sh
/etc/suse-ignored-rpaths.conf

%changelog
* Thu May 12 2016 lnussel@suse.de
- Update to version 13.2+git20160512.be9650e:
  * Do not remove packages that had a corresponding -mini installed
* Mon Aug 10 2015 lnussel@suse.de
- Update to version 13.2+git20150810.2703d2a:
  + Fix quoting of TOPDIR in regex pattern
  + Skip 03-check-binary-kernel-log for kernel-docs package
* Tue Mar 24 2015 lnussel@suse.de
- Update to version 13.2+git20150324.8993d63:
  + an empty main() is now allowed in C, use a different function
* Tue Oct  7 2014 dmueller@suse.com
- Update to version 13.2+git20141007.c6e35c3:
  + Fix check for skipping libgcc/libstdc++
* Tue Mar 18 2014 ro@suse.com
- also allow -MM additional to -MD to asssume were only generating deps
* Thu Feb 20 2014 ro@suse.de
- test for existence before trying to modify /etc/sysconfig/clock
* Tue Feb  4 2014 ro@suse.com
- do not remove libgcc or libstdc++ packages in install-check
* Fri Jan 31 2014 ro@suse.de
- adapt uname linking in specfile to /usr move (bnc#860600)
* Fri Jan 31 2014 ro@suse.com
- adapt uname.sh helper to 3.XX.Y kernel versioning scheme
- obs removes dashes...
- fix mktar to match service file
- do not mount and umount /proc in checks - the build script handles that
* Thu Jan  9 2014 coolo@suse.com
- the switching to services undid the mounting fix - without me
  noticing. Now really pushed to the right git and redid tar
* Tue Jan  7 2014 coolo@suse.com
- switch to _service file to avoid silent tar updates
* Tue Jan  7 2014 coolo@suse.com
- remove mounting and unmounting of /proc - build handles it
* Mon Dec  9 2013 ro@suse.com
- merge rest of quoting fixes from schwab
* Mon Dec  9 2013 ro@suse.com
- fix quoting in libtool deps check
* Fri Oct 11 2013 coolo@suse.com
- make use of the same findfileconflicts as the one repo-checker uses
- switched repo location to github
* Mon Dec 10 2012 coolo@suse.com
- buildrequire malloc check
* Wed Nov 14 2012 ro@suse.com
- Remove timestamp prefix in check_gcc_output (thanks to schwab)
* Sat Oct 27 2012 coolo@suse.com
- the scripts call awk, so we need to require it
* Thu Oct  4 2012 dmueller@suse.com
- merge /proc mount/umounting patch from AJ
- add _service file to easily recreate the tarball from git
* Sun Sep 23 2012 coolo@suse.com
- change the permissions check to use chkstat directly,
  possibly this check outdated itself though
* Mon Sep 17 2012 coolo@suse.com
- with rpm 4.10, two packages packaging the same directory with
  different owners is a bug - so catch it early
* Tue Jun 26 2012 lnussel@suse.de
- use mkpackage from aaa_base, more advanced
- merge package patches into git
* Tue Jun 26 2012 saschpe@suse.de
- Update reserved init script names from LANANA.
  The current authoritative list is currently found here:
  http://stewbenedict.org/lsb/lanana/lsbreg/init/init.txt
* Mon Jun  4 2012 coolo@suse.com
- ld.so is basically empty nowadays, so put together a config file
  just to ignore rpaths
* Mon May 28 2012 coolo@suse.com
- strim white space in check_gcc_output - this reduces the time
  to check an openSUSE-images log file (38M mostly whitespace due
  to zypper output) from several hours to some seconds
* Tue Dec 20 2011 werner@suse.de
- ignore empty rpm as in 09-check-packaged-twice as those will be
  detected by rpmlint rules with a clear message
* Wed Dec  7 2011 coolo@suse.com
- ignore debuginfo and debugsource packages for packaged-twice
* Thu Dec  1 2011 coolo@suse.com
- fix usage of perl's index()
* Mon Nov 28 2011 coolo@suse.com
- ignore files that are %%ghost in both packages
* Fri Nov 25 2011 coolo@suse.com
- make "packaged twice" fatal if packages do not conflict
* Thu Oct 20 2011 ro@suse.com
- use /.build.packages instead of /usr/src/packages if it exists
* Fri Jul 22 2011 lnussel@suse.de
- Fix filelist check for new rpm
* Wed Jun 22 2011 dmueller@suse.de
- fix strict-aliasing compiler check with gcc 4.6
* Tue Jun 21 2011 dmueller@suse.de
- re-enable fatal checks in 04-check-filelist as the deadline has
  passed
* Fri Mar 25 2011 ro@suse.de
- drop sync workaround again
* Sun Mar 20 2011 ro@suse.de
- add helper/sync.sh to disable sync inside build environment
* Tue Dec  7 2010 lnussel@suse.de
- re-enable fatal checks in 04-check-filelist as the deadline has
  passed
* Tue Nov 30 2010 lnussel@suse.de
- maintain sources in git
* Mon Nov  8 2010 lnussel@suse.de
- disarm 04-check-filelist for now. Too many failures.
* Thu Nov  4 2010 lnussel@suse.de
- revive 04-check-filelist part that checks for unpackaged
  directory. Not possible to implement with rpmlint atm.
* Mon May 31 2010 sbrabec@suse.cz
- Removed 11-check-pkgconfig-deps as it is now part of rpm
  (bnc#610280).
* Thu May  6 2010 lnussel@suse.de
- finally remove 04-check-filelist as it's obsoleted by
  CheckFilelist.py in rpmlint
* Wed Apr  7 2010 ro@suse.de
- remove debuginfo packages for nosrc rpms unless
  package is either kernel or java or texlive-bin or glibc
  or removal is disabled in specfile by adding a line
  [#]KEEP NOSOURCE DEBUGINFO
  to the specfile (bnc#572695)
* Tue Feb 23 2010 ro@suse.de
- check gcc warnings: wording for non-void return has changed
* Fri Feb 19 2010 mls@suse.de
- allow /usr/src/parrot in parrot-devel
* Sat Feb  6 2010 detlef@links2linux.de
- add umount patch: Umount $BUILD_ROOT/proc after finished job
* Mon Dec  7 2009 mmarek@suse.cz
- do not mess with sysconfig files when installed in a live system
  (no more missed appointments...).
* Thu Nov  5 2009 meissner@suse.de
- move strcasecmp and strlcpy to "implict warning" as we have
  no specific fortify checking for those.
* Tue Oct 20 2009 meissner@suse.de
- merge debuginfo patch into tarball
- check for "implicit declaration of function 'xxxx'" with a fixed
  list of standard library xxxx which will change behaviour when having
  correct declaration.
* Mon Aug 10 2009 ro@suse.de
- allow /selinux in filelist check
* Thu Jul 30 2009 rguenther@suse.de
- simplify and fix empty debuginfo/source deletion
* Mon Jul 27 2009 rguenther@suse.de
- also remove empty debugsource packages
* Wed Jun 24 2009 coolo@novell.com
- reenable -as-needed now that most of the fallout is fixed
* Sat Jun 13 2009 coolo@novell.com
- take out AS_NEEDED for now to see a before-after comparision
* Wed Jun 10 2009 coolo@novell.com
- add a profile.d script that sets -as-needed when in build environment
* Tue May 26 2009 ro@suse.de
- fix last change
* Fri May 22 2009 ro@suse.de
- more ugly tweaks to uname hack
* Mon Feb 23 2009 ro@suse.de
- cleanup uname hack in preun (bnc#476885)
* Fri Feb 20 2009 coolo@suse.de
- don't make the sequence point gcc warnings fatal, but let security
  team review them case by case
* Tue Oct 28 2008 lnussel@suse.de
- remove suid check. replaced by rpmlint script
* Mon Oct 27 2008 meissner@suse.de
- added warning checks for: array subscript over/underflow,
  void return not expected warnings. bnc#240922,bnc#439283
* Thu Oct 23 2008 lnussel@suse.de
- suid check: tetex -> texlive
* Wed Oct 22 2008 lnussel@suse.de
- don't fail for setuid/setgid directories (bnc#437721)
- some cleanups
* Wed Oct 22 2008 lnussel@suse.de
- failed setuid check is fatal (bnc#431592)
* Tue Oct 14 2008 dmueller@suse.de
- remove extra whitespace in warning output that confuses people
* Mon Oct 13 2008 ro@suse.de
- allow /opt/IBMJava2-*
* Tue Oct  7 2008 meissner@suse.de
- testsuite for check_gcc_output. marked the currently non
  working tests as "BROKEN.C" (not built).
- fixed implicit fortify function check to work with newer gccs.
* Mon Oct  6 2008 meissner@suse.de
- added checks for newer glibcs destination buffer overflow
  warning.
* Tue Sep 30 2008 ro@suse.de
- make uname.sh more robust
* Tue Sep 23 2008 dmueller@suse.de
- remove uses-function-address debug statement, confuses more
  people than it helps
* Mon Sep 15 2008 ro@suse.de
- allow /opt/IBMJava2-142
* Fri Sep  5 2008 ro@suse.de
- next hack for uname.sh: if /.kernelversion does not exist
  use a readlink on /usr/src/linux to find out
  and then get the flavor by the same hack as kernel-source
* Thu Sep  4 2008 ro@suse.de
- added COPYING file
* Wed Sep  3 2008 ro@suse.de
- try not to remove library packages during initial build
  (when updating soname bnc#421981)
* Wed Aug 20 2008 ro@suse.de
- allow /var/crash for crash-dumps (FHS-2.3)
- allow /branding (installation-images)
* Fri Aug 15 2008 ro@suse.de
- make sure LOGFILE is set for gcc warning check
* Mon Aug 11 2008 ro@suse.de
- eliminate use of BUILD_IS_RUNNING
* Mon Aug 11 2008 ro@suse.de
- eliminate use of BUILD_BASENAME and package_name
* Sun Aug 10 2008 ro@suse.de
- add uname hack: let "uname -r" return the version of the
  installed kernel-sources, not the one of the running kernel
* Fri Aug  8 2008 ro@suse.de
- some sysconfig hacks:
  sysconfig/security:PERMISSION_SECURITY to secure
  sysconfig/clock:TIMEZONE to UTC
- add PreReq "aaa_base permissions sed" to make this work
* Mon Aug  4 2008 ro@suse.de
- change debuginfo dependency checker:
  only fail on dependencies not referring to debuginfo packages
* Mon Jul 28 2008 ro@suse.de
- fail if a debuginfo or debugsource package has
  an unresolvable dependency
* Tue Jul 15 2008 ro@suse.de
- replace last cleanup_and_exit by exit
- make sure proc is mounted before uninstalling rpms
- export YAST_IS_RUNNING during all install/uninstall tests
* Mon Jul 14 2008 ro@suse.de
- added 00-install and 99-remove as next part of main build script
* Mon Jul 14 2008 ro@suse.de
- created package
